#include <system.h>
#include "control.h"
#include "dotclock.h"
#include "display.h"
#include "Eprom_Functions.h"
extern unsigned char nRTC[8];
extern unsigned int nTimeCount;
extern unsigned char n10Hours, nHours, n10Mins, nMins;

//FUNCTION to send a short beep out BUZZER_PIN
void play_tone(void)
{
	unsigned int i;
	unsigned int k;
	
	for(i=0;i<200;i++)
	{
		k = 10;
		set_bit(porta,BUZZER_PIN);
		delay_10us(k);
		clear_bit(porta,BUZZER_PIN);
		delay_10us(k);
	};
	return;
};

//FUNCTION to scan the switches to see if user wants to set the time
//after time is set the RTC is updated
void scan_switches(void)
{
	unsigned char n; 
	unsigned char i;
	n = SW_PORT & SW_NOPRESS;	//see if any keys are pressed
	if (n==SW_NOPRESS) 
		return;	//nope, so do nothing
	if (!test_bit(SW_PORT,SW1_PIN))
	{
		n = 0;
		delay_ms(300);
		if(!test_bit(SW_PORT,SW1_PIN))
			play_tone();
		//go into set mode
		while(test_bit(SW_PORT,SW1_PIN))
		{
			nTimeCount = TICK_TIME;	//keep clock from ticking over while doing setting
			if(!test_bit(SW_PORT,SW2_PIN))
			{
				n++;
				if(n==4)n=0;
				delay_ms(150);
			}
			if(!test_bit(SW_PORT,SW3_PIN))
			{
				switch(n)
				{
					case 0:
						n10Hours++;
						if(n10Hours==6)n10Hours=0;
						break;
					case 1:
						nHours++;
						if(nHours==10)nHours=0;
						break;
					case 2:
						n10Mins++;
						if(n10Mins==6)n10Mins=0;
						break;
					case 3:
						nMins++;
						if(nMins==10)nMins=0;
						break;
				}
				display_time();
				delay_ms(150);
			}
		}
	}
	//Update the RTC using parameters as set by the user
	n10Hours = n10Hours & 0x03;
	nRTC[0] = 00;
	nRTC[1] = (n10Mins<<4) | nMins;
	nRTC[2] = (n10Hours<<4) | nHours;
	nRTC[3] = 3;	//dont care about calendar at the moment
	nRTC[4] = 4;
	nRTC[5] = 5;
	nRTC[6] = 00;
	nRTC[7] = 0x10;
	write_rtc();
	//i = write_rtc();
	play_tone();
	delay_ms(500);
	play_tone();
	delay_ms(500);
	nTimeCount = TICK_TIME;
	return;
}