#include <system.h>
#include "rand.h"
#include "dotclock.h"
#include "control.h"
#include "display.h"

#pragma CLOCK_FREQ 8000000

// Set configuration word
#ifdef _PIC16
	#pragma DATA _CONFIG1, _CP_OFF & _CCP1_RB0 & _DEBUG_OFF & _WRT_PROTECT_OFF & _CPD_OFF & _LVP_OFF & _BODEN_ON & _MCLR_OFF & _PWRTE_ON & _WDT_OFF & _INTRC_IO 
	#pragma DATA _CONFIG2, _IESO_OFF & _FCMEN_OFF 
#endif //_PIC16

unsigned char n10Hours=0, nHours=0, n10Mins=0, nMins=0;

void main()
{
	unsigned int i,t;
	unsigned char j;
	unsigned char k;
	
	osccon = 0x76;			//magic code to start 16F88 in internal osc 8Mhz mode
	while( (osccon & 0x04)==0);

	//setup peripherals
	porta = 0;
	portb = 0;
	cmcon = 0x07;			//disable comparator output, do now to set trisa properly
	trisa = SWTRIS_INIT;	//All except RA5 set to output, RA5 always input anyway
	trisb = 0x00;			//all pins in portb set to output
	ansel = 0;
	option_reg=0x00;		//set /32 prescale on timer0
	tmr0 = 0xff;
	
	//Start with full display
	nHours = 9;
	nMins = 9;
	n10Hours = 5;
	n10Mins = 5;

	//Start display update timer
	clear_bit(pir1,TMR1IF);
	set_bit(pie1,TMR1IE);
	set_bit(intcon, GIE);
	set_bit(intcon, PEIE);
	
	//enable switch interface
	set_bit(SW_PORT,SWPWR_PIN);
	t1con = 0x01;
	
	//show startup display
	display_time();
	
	delay_s(1);
	//start timer
	init_display();
	
	while(1)
	{
		//update approx every 5 seconds the randomness of display, scan switches always
		for(i=0;i<5000;i++)
		{	
			delay_ms(1);
			scan_switches();
		};
		
		//get time from RTC and update display
		get_time();
		display_time();
	}

	
}
